IMPLEMENTATION MODULE MenuScreen;           (*gemaakt door Xenios Tillez*)
<* WOFF + *>
<* NOOPTIMIZE + *>
FROM IO IMPORT RdChar, WrChar, WrStr, RdStr, WrLn, RdLn, RdCard, WrCard, 
RdInt, WrInt, RdReal, WrReal, WrFixReal, RdBool, WrBool, RdKey, KeyPressed;
FROM Graph IMPORT Init, Line, Rectangle, Circle, Disc, Polygon, RawOutText, 
Exit;(*graphics library *)
FROM Graph IMPORT _clrBLACK, _clrBLUE, _clrGREEN, _clrCYAN, 
_clrRED,_clrMAGENTA, _clrBROWN, _clrWHITE, _clrGRAY, 
_clrLIGHTBLUE,_clrLIGHTGREEN, _clrLIGHTCYAN, _clrLIGHTRED, 
_clrLIGHTMAGENTA,_clrLIGHTYELLOW, _clrBRIGHTWHITE;
FROM Graph IMPORT ClearScreen, Plot, GetImage, PutImage, _GPSET, SetBkColor;
FROM StandardLib IMPORT StrLength,StrCompare, StrCopy, StrConcatenate, 
StrAr;
FROM ModifiedStandardBitmap IMPORT BITMAP_SIZE, DIGIT_SIZE, BitmapEn,DrawBitmap,
DrawNumber, DrawDigit, DrawBitmapFile, DrawSavedBitmap;
FROM StandardMouse IMPORT InitMouseGraphWindow, UpdateMouse, 
GetMouseX,GetMouseY, MouseButton, IsButtonPressed;
FROM Lib IMPORT Delay;
FROM RealMath IMPORT sqrt, exp, sin, cos, tan, arcsin, arccos, arctan, 
power, round, pi;
FROM SYSTEM IMPORT NEW, DISPOSE;
FROM WholeStr IMPORT CardToStr;
FROM Str IMPORT Insert;
FROM StandardSound IMPORT SoundEventEn, InitSound, PlaySoundEvent;



CONST TEXT_WIDTH = 7; (* letter size in pixels *)
      TEXT_HEIGHT = 16;
      DELAY_TIME= 1000;
      SSX=875;
      SSY=700;
VAR
x: CHAR;

bmpAr : ARRAY[1..8] OF CARDINAL;

PROCEDURE TekenKnop(Startx, Starty, Eindx, Eindy : CARDINAL; ColourKnop, ColourTekst: CARDINAL; Tekst:ARRAY OF CHAR);
VAR oldCol :CARDINAL;
BEGIN
oldCol:=SetBkColor( 3);
Rectangle (Startx, Starty, Eindx, Eindy, ColourKnop, TRUE);
Rectangle (Startx, Starty, Eindx, Eindy, _clrBLACK, FALSE);
RawOutText (Startx + ( (Eindx-Startx-VAL(CARDINAL, VAL(REAL ,StrLength(Tekst))*7.5)) / 2), Starty + ((Eindy-Starty-14)/2), ColourTekst,
Tekst);
oldCol:=SetBkColor(oldCol);
END TekenKnop;

PROCEDURE BeginScherm;
VAR width, height :CARDINAL;
BEGIN
ClearScreen(1);
Rectangle(0,0,SSX,SSY, 1 ,TRUE) ;
IF bmpAr[5] = 0 THEN (* slow drawing first time, then faster drawing *) ;
bmpAr[5]:= DrawBitmapFile(40,0, "Pictures/europeansupremacy2.bmp", width, 
height );
ELSE DrawSavedBitmap(40,0, bmpAr[5]); (* to get it right in the middle of
the screen *)
END; (* IF bmpID *)

TekenKnop(SSX-325, SSY/15, SSX-125 , SSY/15+100, _clrCYAN, 0, "Play Game");
TekenKnop(SSX-325, SSY/15+150, SSX-125 , SSY/15+250, _clrCYAN, 0 , "Tutorial");
TekenKnop(SSX-325, SSY/15+300, SSX-125 , SSY/15+400, _clrCYAN, 0 , "Credits");
TekenKnop(SSX-325, SSY/15+450, SSX-125 , SSY/15+550, _clrCYAN, 0 , "Quit")  ;


IF bmpAr[1] = 0 THEN
bmpAr[1]:= DrawBitmapFile(100,200, "Pictures/cavalerie16k.bmp", width, 
height );
ELSE DrawSavedBitmap(100,200, bmpAr[1]);
END; (* IF bmpID *)

END BeginScherm;

PROCEDURE Credits;
VAR 	width, height:CARDINAL;
	oldCol:CARDINAL;
BEGIN
oldCol:=SetBkColor(1) ;              (*wijzigt de achtergrond van de tekst*)
ClearScreen(0);

Rectangle(0,0,SSX,SSY,1,TRUE);
RawOutText(375,25,_clrBRIGHTWHITE,'CREDITS');
Line(375,42,429,42,_clrBRIGHTWHITE);
RawOutText(25,75,_clrBRIGHTWHITE,'Dit spel werd gecrerd door :');
RawOutText(25,135,_clrBRIGHTWHITE,'Xenios Tillez');
RawOutText(25,115,_clrBRIGHTWHITE,'Yannick Lefevre');
RawOutText(25,155,_clrBRIGHTWHITE,'Sybren Van der Straeten');
RawOutText(25,205,_clrBRIGHTWHITE,'Eerste Bachelor Ingenieurswetenschappen');
RawOutText(25,225,_clrBRIGHTWHITE,'In opdracht van: Vrije Universiteit Brussel');
RawOutText(25,245,_clrBRIGHTWHITE,'academiejaar 2005-2006');
oldCol:=SetBkColor(oldCol);

TekenKnop((SSX/2)-50, SSY-200, (SSX/2)+50 ,SSY-150 , _clrCYAN, 0 , "Back");

IF bmpAr[2] = 0 THEN
bmpAr[2]:= DrawBitmapFile(500,100, "Pictures/infanterie16k.bmp", width, 
height );
ELSE DrawSavedBitmap(500,100, bmpAr[2]);
END;  (*IF bmpID*)
LOOP
   IF UpdateMouse() THEN
      IF IsButtonPressed(LEFT_BUTTON) THEN
         CASE GetMouseX() OF (SSX/2)-50..(SSX/2)+50:
            IF (GetMouseY()>= SSY-200 )AND (GetMouseY()<= SSY-150) THEN
            EXIT ;
            ELSE ;
            END;   (*IF GetMouseY*)
	  ELSE;
         END;    (*Case*)
      END;    (*IF IsButtonPressed*)
   END;    (*UpdateMouse*)
END;      (*Loop*)
BeginScherm;
END Credits;

PROCEDURE instructions2;
VAR width, height:CARDINAL;
BEGIN
ClearScreen(0);
Rectangle(0,0,SSX,SSY, 1,TRUE);
IF bmpAr[7] = 0 THEN
    bmpAr[7]:= DrawBitmapFile(SSX/2-240,50, "Pictures/tutorial2.bmp", width,
height );
ELSE DrawSavedBitmap(SSX/2-240, 50, bmpAr[7]);
END; (* IF bmpID *)
TekenKnop((SSX/2)+50, SSY-200, (SSX/2)+150 ,SSY-150 , _clrCYAN, 0 , "Back");
END instructions2;

PROCEDURE instructions;
VAR width, height:CARDINAL;
BEGIN
ClearScreen(0);
Rectangle(0,0,SSX,SSY, 1,TRUE);

IF bmpAr[6] = 0 THEN
bmpAr[6]:= DrawBitmapFile(SSX/2-240,20, "Pictures/tutorial1.bmp", width,
height );
ELSE DrawSavedBitmap(SSX/2-240, 20, bmpAr[6]);
END; (* IF bmpID *)

TekenKnop((SSX/2)-150, SSY-200, (SSX/2)-50 ,SSY-150 , _clrCYAN, 0 , "Next");
TekenKnop((SSX/2)+50, SSY-200, (SSX/2)+150 ,SSY-150 , _clrCYAN, 0 , "Back");

LOOP
   IF UpdateMouse() THEN
       IF IsButtonPressed(LEFT_BUTTON) THEN
            IF (GetMouseY()>= SSY-200 )AND (GetMouseY()<= SSY-150) THEN
	       CASE GetMouseX() OF (SSX/2)-150..(SSX/2)-50:
	          instructions2;

              |(SSX/2)+50..(SSX/2)+150 :EXIT;
               ELSE;
               END;     (*CASE GetMouseX *)
           END;    (*IF*)
       END;    (*IF IsButtonPressed*)
   END;     (*IF UpdateMouse*)
END;   (*LOOP*)
BeginScherm;
END instructions;

PROCEDURE IntroScreen():BOOLEAN;            (*het eigenlijke beginscherm*)
VAR oldCol:CARDINAL;
    endIntroScreen:BOOLEAN;
BEGIN       (*begin van introscreen*)

(*oldCol:=SetBkColor( 3);  *)

bmpAr[1]:=0;
bmpAr[2]:=0;
BeginScherm;
endIntroScreen:=FALSE;
LOOP
  IF UpdateMouse() THEN
      IF IsButtonPressed(LEFT_BUTTON) THEN
          IF (GetMouseX()>=(SSX-325) ) AND (GetMouseX()<=(SSX-125)) THEN
            CASE
              GetMouseY() OF SSY/15..SSY/15+100:
	         (*PlaySoundEvent(STILTE);*)
	         endIntroScreen:=TRUE;    (*knoppen definieren*)
	      	 EXIT;
             | SSY/15+150..SSY/15+250: instructions;
             | SSY/15+300..SSY/15+400: Credits;
	     | SSY/15+450..SSY/15+550: PlaySoundEvent(STILTE); EXIT;
             | ELSE BeginScherm;

            END; (*CASE*)
          END; (*IF GetMouseX*)
       END;  (*IF IsButtonPressed*)
   END;     (*IF UpdateMouse*)
END; (*LOOP*)
oldCol:=SetBkColor(oldCol);
RETURN endIntroScreen;
END IntroScreen;

PROCEDURE  eindschermWinner(winner : CARDINAL);     (*als er een winnaar is*)

VAR oldCol, width, height		:	CARDINAL;
    tekst1, tekst2			:	ARRAY [1..15] OF CHAR;
BEGIN
(*oldCol:=SetBkColor( 3);   *)      (*change backgroundcolor*)
Rectangle(0,0,875,700, 1 ,TRUE) ;
TekenKnop((SSX/2)-150, SSY-200, (SSX/2)-50 ,SSY-150 , _clrCYAN, 0 , "Menu");
TekenKnop((SSX/2)+50, SSY-200, (SSX/2)+150 ,SSY-150 , _clrCYAN, 0 , "Quit");

oldCol:=SetBkColor(1);
bmpAr[3]:=0;
IF bmpAr[3] = 0 THEN (* slow drawing first time, then faster drawing *) ;
bmpAr[3]:= DrawBitmapFile(220,45, "Pictures/eindschermwinner2.bmp", width,
height );
ELSE DrawSavedBitmap(220,45, bmpAr[3]); (* to get it right in the middle of
the screen *)
END; (* IF bmpID *)


IF bmpAr[8] = 0 THEN (* slow drawing first time, then faster drawing *) ;
bmpAr[8]:= DrawBitmapFile(250,265, "Pictures/kanon.bmp", width, height );
ELSE DrawSavedBitmap(250,265, bmpAr[8]); (* to get it right in the middle of
the screen *)
END; (* IF bmpID *)

tekst1:='Player ';
tekst2:=' ';
CardToStr(winner, tekst2);
StrConcatenate(tekst1, tekst2);
RawOutText(300,20, 4,tekst1);
RawOutText(370,20, 4,'has won this game!!!');
oldCol:=SetBkColor( oldCol);
END eindschermWinner;


PROCEDURE eindschermUndecidedGame();      (* voor als het spel niet werd uitgespeeld*)

VAR oldCol, width, height		:	CARDINAL;
BEGIN
  (*oldCol:=SetBkColor( 3);*)
  Rectangle(0,0,SSX,SSY, 1 ,TRUE) ;
  TekenKnop((SSX/2)-150, SSY-200, (SSX/2)-50 ,SSY-150 , _clrCYAN, 0 , "Menu");
  TekenKnop((SSX/2)+50, SSY-200, (SSX/2)+150 ,SSY-150 , _clrCYAN, 0 , "Quit");
  (*oldCol:=SetBkColor(oldCol);*)
  bmpAr[4]:=0;
  IF bmpAr[4] = 0 THEN
  bmpAr[4]:= DrawBitmapFile(100,60, "Pictures/undecisive.bmp", width, height);
  ELSE DrawSavedBitmap(100,60, bmpAr[4]);
  END;
  oldCol:=SetBkColor( 1);
  RawOutText(260,25,_clrBRIGHTWHITE,' It has been a furious yet undecided game!! ');
  oldCol:=SetBkColor(oldCol);
END eindschermUndecidedGame;

PROCEDURE OutroScreen(winnerBo:BOOLEAN; player: CARDINAL):BOOLEAN;

VAR res: BOOLEAN;
BEGIN                               (*het eigenlijke eindscherm*)
PlaySoundEvent(INTRO);
IF winnerBo THEN
  eindschermWinner(player);
  ELSE eindschermUndecidedGame (* alternatief eindscherm met knoppen op dezelfde plaats *)
  END;
  LOOP
	IF UpdateMouse() THEN
		IF IsButtonPressed(LEFT_BUTTON) THEN
		  IF (GetMouseY()>= SSY-200 )AND (GetMouseY()<= SSY-150) THEN
	            CASE GetMouseX() OF
		         (SSX/2)-150..(SSX/2)-50: res:=TRUE;EXIT;
	                |(SSX/2)+50..(SSX/2)+150: res:=FALSE;EXIT;
		    END;  (*case*)
		  END;   (*IF*)
		END;     (*IF*)
	END;     (*IF*)
  END;       (*loop*)

RETURN res;
END OutroScreen;

END MenuScreen.

